/* > fd_win32.c */
/* convert HANDLE to int (file descriptor) */

#include "fd_win32.h"

#define HANDLES 16
#define FDOFFSET 3

struct handlelist_s;
typedef struct handlelist_s handlelist;
struct handlelist_s {
	handlelist *next;
	int offset;
	int used;
	HANDLE handle[HANDLES];
	};	

static handlelist *masterlist=NULL;

static handlelist *newhl(handlelist *last) {
	handlelist *r;
	int i;
	r=calloc(1,sizeof(*r));
	if (!r) return NULL;
	for(i=0;i<HANDLES;i++) r->handle[i]=INVALID_HANDLE_VALUE;
	if (last) {
		r->offset=last->offset+HANDLES;
		last->next=r;
		}
	else {
		r->offset=FDOFFSET;
		}
	return r;
	}

int fdw32_newfd(HANDLE h) {
	handlelist *hl,*lasthl=NULL;
	int fd;
	if (!masterlist) masterlist=newhl(NULL);
	if (!masterlist) return -1;
	for(hl=masterlist;hl && hl->used >= HANDLES;hl=hl->next) lasthl=hl;
	if (!hl) hl=newhl(lasthl);
	if (!hl) return -1;
	for(fd=0;fd<HANDLES;fd++)
		if (hl->handle[fd]==INVALID_HANDLE_VALUE) break;
	if (fd>=HANDLES) /* something wrong */ return -1;
	hl->handle[fd]=h;
	return fd+hl->offset;
	}

static handlelist *findhl(int fd) {
	handlelist *hl;
	for(hl=masterlist;hl;hl=hl->next)
		if (fd>=hl->offset && fd<hl->offset+HANDLES) return hl;
	return NULL;
	}

HANDLE fdw32_gethandle(int fd) {
	handlelist *hl=findhl(fd);
	if (!hl) return INVALID_HANDLE_VALUE;
	return hl->handle[fd-hl->offset];
	}

void fdw32_deletefd(int fd) {
	handlelist *hl=findhl(fd);
	if (!hl) return;
	hl->handle[fd-hl->offset]=INVALID_HANDLE_VALUE;
	}
