.TH DALIB 3 "November, 1996" DALIB "Digital Audio Tape Library 0.1"
.SH NAME
da_read \- read from the device associated with a DAT descriptor
.SH SYNOPSIS
.B #include "dataudiolib.h"
.sp
.B int
.br
.BI "da_read(int  datfd ,unsigned char* data ,int size )"
.SH DESCRIPTION
The
.B da_read()
function reads a chunk of audio data on the device specified by datfd.
The function will convert the audiodata from the DAT internal format from
the device/file/stream associated with 
.B datfd
\& and convert it into 
.B data
\&. The data read from datfd is being buffered.
.br 
This function decodes the subcode information from any DAT frame it reads 
and stores it into the internal state structures, where it can be read using
.B da_control
\&. It also handles calling registred callbacks on subcode data change. See
.B da_add_callback(3)
for more information.
.SH PARAMETERS
.SS Input Parameters
.IP datfd
A filedescriptor returned by da_open or da_init.
(alternating left and right channel).
.IP size
The size of the audiodata buffer.
.SS Output Parameters
.IP data
Will contain the audiodata consisting of 16 bit linear encoded stereo samples
.SH RETURN VALUE
This function returns the number of bytes stored into data.
.br
When an error condition arises, this routine returns -1 and sets errno to
indicate the reason for the error.  Possible values of errno are:
.TP
EINVAL
The filedescriptor is invalid.
.TP
other
All errnos that can be returned by 
.B read(2)
\&.
.SH USAGE EXAMPLE
.PP
Read 4096 bytes of audiodata.
.PP
.nf
		unsigned char	data[4096];
		int		res;

		res=da_read(datfd,data,4096);
		if (res==-1) {
			perror("da_read");
		}
.fi
.SH SEE ALSO
.B da_intro(3),da_write(3)
.SH AUTHOR
Marcus Meissner <msmeissn@cip.informatik.uni-erlangen.de>
